HDU1973(Prime Path)

Prime Path

題目傳送門

Problem Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
—I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
—In fact, I do. You see, there is this programming contest going on. . .

Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input
3
1033 8179
1373 8017
1033 1033

Sample Output
6
7
0

思路

給定兩個素數,問這兩個素數通過各種狀態轉移修改最少需要多少步才能完成。一維數字搜索裸題,先預打表1000-9999的素數吧。歐拉篩 或者 埃篩有點殺雞用牛刀的感覺。狀態判重也沒什麼技巧,也是比較簡單的一道題。

#include <iostream>
#include <cstring>
#include <cstdio>
#include <queue>
#include <algorithm>
using namespace std;
const int maxn = 1e5+5;
bool prime[maxn];
bool visited[maxn]; 
struct node{
    int num,t;
};
void getprime()
{
    memset(prime,true,sizeof(prime));
    prime[0] = prime[1] = false;
    for(int i = 2;i < maxn;i++){
        if(prime[i]){
            for(int j = 2*i;j < maxn;j += i){
                prime[j] = false;
            }
        }
    }
}
queue<node>q;
void bfs(int y)
{
    while(!q.empty()){
        node ptr = q.front(),p;
        q.pop();
        if(ptr.num == y){
            printf("%d\n",ptr.t);
            return ;
        }
        int a[4];
        a[0] = ptr.num/1000;a[1] = ptr.num/100%10;
        a[2] = ptr.num/10%10;a[3] = ptr.num%10; 
    //    cout<<a[0]<<" "<<a[1]<<" "<<a[2]<<" "<<a[3]<<endl;
        for(int i = 0;i < 4;i++){
            for(int j = 1;j <= 10;j++){
                if(i == 0){
                    int t = (a[0] + j)%10;
                    int x = t*1000+a[1]*100+a[2]*10+a[3];
                    if(t != a[0] && t != 0 && prime[x] == true && visited[x] == false){
                        p.num = x;p.t = ptr.t + 1;
                        visited[x] = true;
                        q.push(p);
                    }
                }
                if(i == 1){
                    int t = (a[1] + j)%10;
                    int x = a[0]*1000+t*100+a[2]*10+a[3];
                    if(t != a[1] && prime[x] == true && visited[x] == false){
                        p.num = x;p.t = ptr.t + 1;
                        visited[x] = true;
                        q.push(p);
                    }
                }
                if(i == 2){
                    int t = (a[2] + j)%10;
                    int x = a[0]*1000+a[1]*100+t*10+a[3];
                    if(t != a[2] && prime[x] == true && visited[x] == false){
                        p.num = x;p.t = ptr.t + 1;
                        visited[x] = true;
                        q.push(p);
                    }
                }
                if(i == 3){
                    int t = (a[3] + j)%10;
                    int x = a[0]*1000+a[1]*100+a[2]*10+t;
                    if(t != a[3] && prime[x] == true && visited[x] == false){
                        p.num = x;p.t = ptr.t + 1;
                        visited[x] = true;
                        q.push(p);
                    }
                }
            }
        }
    }
}
int main()
{
    getprime();
    int t,x,y;
    scanf("%d",&t);
    while(t--){
        scanf("%d%d",&x,&y);
        node p;
        memset(visited,false,sizeof(visited));
        while(!q.empty()){
            q.pop();
        }
        p.num = x;p.t = 0;
        q.push(p);
        visited[x] = true;
        bfs(y);
    }    
    return 0;
} 

願你走出半生,歸來仍是少年~

發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章